// Beliefs
manager("Manager@touragent:1099/JADE").

// Team of troop.
team("ALLIED").
// Type of troop.
type("CLASS_MEDIC").

// List of tasks.
// Each task has the following structure:
// task(Priority, Type, ActivatorAgent, Position, Content).
tasks([]).

// List of objects in Field Of View.
fovObjects([]).

// Aimed Agent.
//aimed_agent(AimedAgent).

// Indicates if agent has the flag or not.
//carrying_flag.

// Initial state in Finite State Machine.
state(standing).

// Goals
!start.

// Plans

/*******************************
*
* Finite State Machine definition
*
*******************************/
+!fsm : state(standing)
	<- 	//operar
		//update_my_position;
		//.println("HAY TAREAS??");
		?tasks(Tasks);
		.length(Tasks, TaskListLength);
		if (TaskListLength <= 0) {
			!!fsm;
			.fail;
		}
		//.println("SÍ");
		
		//.println("TENGO SALUD??");
		?my_health(Health);		
		if (Health <= 0) {
			.println("ESTOY MUERTO Y ME VOY AL ESTADO QUIT");
			-+state(quit);			
			tasks([]);
			!!fsm;
			.fail;
		}
		//.println("SÍ");
		
		!update_targets;
		
		// Obtain the task with the highest priority from Tasks list.
		//.println("CUÁL ES LA TAREA DE MÁS PRIORIDAD??");
		if(TaskListLength > 0){
			.sort(Tasks, TasksSorted);
			.max(TasksSorted, PrioritaryTask);			
			-+current_task(PrioritaryTask);
			.println("LA TAREA PRIORITARIA AHORA ES ", PrioritaryTask);
			PrioritaryTask = task(_,_,_,CurrentDestination,_);
			//.nth(3, PrioritaryTask, CurrentDestination);
			//.println("Y EL DESTINO ES ", CurrentDestination);
			-+current_destination(CurrentDestination);
			update_destination(CurrentDestination);
			update_my_position;
			-+state(go_to_target);
			!!fsm;
			
			.fail; /// To test if it eliminates the "thread"
		}.

+!fsm : state(go_to_target)
	<- 	//update_my_position;
		// Save the initial time for the first time.
//		?current_task(OT);
//		.println("A POR EL OBJETIVO!!! ", OT);
		if(not initialized_time) {
//			.println("ES LA PRIMERA VEZ QUE ENTRO AQUÍ!!!");		
			.time_in_millis(FirstCurrentTime);
//			.println("SON LAS ", FirstCurrentTime);
			+last_time_move(FirstCurrentTime);
			+last_time_look(FirstCurrentTime);
//			.println("MARCO LA HORA COMO LA DEL PRIMER MOVIMIENTO Y MIRADA!!!");
			+initialized_time;
//			.println("AÑADIDA CREENCIA DE INICIALIZACION DE TIEMPO");
		}
//		.println("DEBERÍA MIRAR A MI ALREDEDOR???");	
		// Need to look?
		.time_in_millis(CurrentTime);
//		.println("Y AHORA SON LAS ", CurrentTime);
		?last_time_look(LastTimeLook);
		DiferentialLookTime = CurrentTime - LastTimeLook;
//		.println("DIFERENTIAL_LOOK_TIME:  ", DiferentialLookTime);
		if (DiferentialLookTime > 500) {
			-+last_time_look(CurrentTime);
			// Look around.
			//.println("HACE MUCHO QUE NO MIRO A MI ALREDEDOR\n>>>>>>>>>LANZO LOOK!!!");
			!look;
            //.println(">>>>>>>>>VUELVO DE LOOK Y LANZO PERFORM_LOOK_ACTION!!!");
			!perform_look_action;
            //.println(">>>>>>>>>VUELVO DE PERFORM_LOOK_ACTION Y LANZO GET_AGENT_TO_AIM!!!");
			!get_agent_to_aim;
            //.println(">>>>>>>>>VUELVO DE GET_AGENT_TO_AIM Y COMPRUEBO SI HAY ALGUIEN BAJO LA MIRA!!!");
			
			if (aimed_agent) {
				// Save current destination.
				?current_destination(OldDestination);
				!perform_aim_action;
				.println("VOY A DISPARAR!!!");
				// Shot.
				shot(0);
				
				// Continue to previous destination.
				?current_task(CT);
				.println("TRAS EL CONFLICTO, SIGO A POR MI OBJETIVO!!! ", CT);
				update_destination(OldDestination);
				update_my_position;
				-+last_time_move(CurrentTime);
			}; // End of if (aimed_agent)
			
			.println("NADA RESEÑABLE A MI ALREDEDOR!!!");
			
		}; // Endo of if (DiferentialTime > 500)
		
		// Can I move?
		?last_time_move(LastTimeMove);
//		.println("ME MOVÍ POR ÚLTIMA VEZ A LAS ", LastTimeMove);
		DiferentialMoveTime = CurrentTime - LastTimeMove;
//		.println("DIFERENTIAL_MOVE_TIME:  ", DiferentialMoveTime);
		if (DiferentialMoveTime < 33) {
			!!fsm;
			.fail;
		}
		
		-+last_time_move(CurrentTime);
		//.println("ME ESTOY MOVIENDO Y SON LAS ", CurrentTime);
		move(DiferentialMoveTime);
		update_my_position;
		//.println("ULTIMA INSTRUCCIÓN DEL PLAN FSM CON STATE = 'GO_TO_TARGET' ");		
		///!!fsm.
		!!fsm;
		
		.fail; /// To test if it eliminates the "thread"
		//.println("HE VUELTO A LLAMAR A FSM");.

+!fsm : state(target_reached)
	<- 	//update_my_position;
		// Task accomplished, time to delete
		?tasks(TaskList);
		//.println(">>>>>>>>>>>>>>>>>HE LLEGADO A MI OBJETIVO!!!\nLA LISTA DE TAREAS ES ", TaskList);
		?current_task(PrioritaryTask);
		
		.delete(PrioritaryTask,TaskList,NewTaskList);
		//.println(">>>>>>>>>>>>>>>>>ELIMINADA LA TAREA ",PrioritaryTask , " LA LISTA CONTIENE ", NewTaskList);
		-current_task(PrioritaryTask);
        -+tasks(NewTaskList);

		//perform_target_reached()
		-+state(standing);
        ///!!fsm.
        
        !!fsm;
		.fail; /// To test if it eliminates the "thread"
        
        
+!fsm : state(fighting).

+!fsm : state(quit)
	<- 	//operar
		.println("It's time to go home.");		
		.my_name(MyName);
		.drop_all_desires;
		.drop_all_events;
		.drop_all_intentions;
		.kill_agent(MyName).

-!fsm.

/*******************************
*
* Actions definitions
*
*******************************/
/////////////////////////////////
//  ADD TASK 
/////////////////////////////////       
+!add_task(task(TaskPriority, TaskType, ActivatorAgent, Position, Content))
    <-  ?tasks(TaskList);
        if (.member(task(_, TaskType, ActivatorAgent, _, _), TaskList)) {
            // Remove the old task
            .delete(task(_, TaskType, ActivatorAgent, _, _), List, ResultList);

            // Add the new one
            .concat(ResultList, [task(TaskPriority, TaskType, ActivatorAgent, Position, Content)], NewT);           
            -+tasks(NewT);
        }
        else {
            .concat(TaskList, [task(TaskPriority, TaskType, ActivatorAgent, Position, Content)], NewT);
            -+tasks(NewT);
        }.

        
+!add_task(task(TaskType, ActivatorAgent, Position, Content))
    <-  ?task_priority(TaskType, TaskPriority);
        !add_task(task(TaskPriority, TaskType, ActivatorAgent, Position, Content)). 


/////////////////////////////////
//  END OF GAME
/////////////////////////////////
+end_of_game[source(M)]
    <-  .println(M, " informs me about the end of the game.");
        -current_task(_);
        -tasks(_);
        -state(_);
        +state(quit);
        !fsm.

/////////////////////////////////
//  GET AGENT TO AIM 
/////////////////////////////////  
/**
* Calculates if there is an enemy at sight.
* 
* This method scans the list <tt> m_FOVObjects</tt> (objects in the Field
* Of View of the agent) looking for an enemy. If an enemy agent is found, a
* value of <tt> TRUE</tt> is returned and variable <tt> m_AimedAgent</tt>
* is updated. Note that there is no criterion (proximity, etc.) for the
* enemy found. Otherwise, the return value is <tt> FALSE</tt>.
* 
* <em> It's very useful to overload this method. </em>
* 
* @return <tt> TRUE</tt>: enemy found / <tt> FALSE</tt> enemy not found
* 
*/  
+!get_agent_to_aim
    <-  .println("Looking for agents to aim.");
        ?fovObjects(FOVObjects);
        .length(FOVObjects, Length);
        if (Length > 0) {
            while(not aimed_agent(AimedAgent) & Loop <= Length) { // where vl(X) is a belief
                .nth(Loop, FOVObjects, Object);
                // Object structure 
                // [#, TEAM, TYPE, ANGLE, DISTANCE, HEALTH, POSITION ]
                // [1, 0, 1003, 0.02683027943550813, 32.648189793865185, -1, pos( 184.0 , 0.0 , 240.0 )]
                // [0,200,2,0.0708307350502304,33.83628166210136,100, pos(182.04807262446008,0.0,232.96699203101343)]
                // [1,200,2,0.11186274827465018,39.05640850827314,100, pos(186.54288595620977,0.0,236.01182650227872)]
                // [2,0,1003,0.0,40.64628455099191,-1, pos(184.0,0.0,240.0)]
                .nth(2, Object, Type);
                if (Type > 1000) {
                    .println("I found some object.");
                } else {
                    // Object may be an enemy
                    .nth(1, Object, Team);
                    ?my_formattedTeam(MyTeam);
                
                    if (MyTeam == Team) {
                    } else {
                        +aimed_agent(Object);
                    }
                }
                Loop = Loop+1;
            };
        }.
       
        
/////////////////////////////////
//  INITIAL SETUP
/////////////////////////////////
+initial_setup(AssignedID, Map)[source(M)] : .my_name(MyName)
    <-  .println(M, " assigned me the ID ", AssignedID);
        +assigned_id(AssignedID);
        .println("The selected battlefield is ", Map);
        +battlefield(Map);
        .println("Beginning to fight").

/////////////////////////////////
//  LOOK NEW
/////////////////////////////////
+!look : not look_response(_) 
    <-  //.wait( {+pos(X,Y)} , 500);
        //.println("DESPUÉS DEL MINI  WAIT");
        //.wait({+look_response(_)}, 5);
        
        //.println("TRAS EL WAIT");
        if (waiting_look_response) {        
            //.println("YA HE ENVIADO UNA SOLICITUD DE MIRAR");
            .time_in_millis(CurrentTime);
            ?last_time_look_msg_sent(LastLookMsgSentTime);
            DiferentialTime = CurrentTime - LastLookMsgSentTime;
            if (DiferentialTime > 5000) {
                -waiting_look_response; 
                .println(">>>>>>>>>>>>>>>>>>>>>>ELIMINO LA CONDICION DE ESPERA Y VUEVLO A LANZAR LOOK");
                    
                //.fail;
            }
            
            // re-run this objective
            //!look;
        
        } else {
        //.println("VOY A PREGUNTAR QUÉ HAY CERCA");
            // Prepare message
            ?manager(M);
            ?assigned_id(AssignedID);
            .concat("ID: ", AssignedID, Content);
        
            // Send         
            .send_msg_with_conversation_id(M, tell, Content, "SIGHT");
        
            // Timestamp
            .time_in_millis(CurrentTime);
            +last_time_look_msg_sent(CurrentTime);
        
            // Wait for response
            +waiting_look_response;
                
           // !!look; 
        }
        !!look.

// Stop condition for look loop.        
+!look : look_response(FOVObjects)
    <-  .println("ACTUALIZADA LA LISTA DE OBJETOS VISTOS.").


/////////////////////////////////
//  LOOK RESPONSE
/////////////////////////////////
+look_response(FOVObjects)[source(M)]
    <-  //-waiting_look_response;
        .length(FOVObjects, Length);
        if (Length > 0) {
            .println("HAY ", Length, " OBJETOS A MI ALREDEDOR:\n", FOVObjects);
        };    
        -look_response(_)[source(M)];
        -+fovObjects(FOVObjects);
        //.//;
        !look.


/////////////////////////////////
//  OBJECTIVE POSITION
/////////////////////////////////
+objective_position(ObjectiveX, ObjectiveY, ObjectiveZ)[source(M)]
    <-  .println("Objective is at [", ObjectiveX,", ", ObjectiveY, ", ", ObjectiveZ,"] position.");
        !add_task(task(1000, "TASK_GET_OBJECTIVE", M, pos(ObjectiveX, ObjectiveY, ObjectiveZ), ""));
        //!update_position;
        update_my_position;
        !fsm.
        /*
        
        update_my_position;
        look;
        
        if (team("ALLIED")){
            .println("I must capture the objective.");
            !capture_the_objective;
        } else {
            .println("I must defend the objective.");
            !defend_the_objective;
        }.*/
        
        
/////////////////////////////////
//  PERFORM ACTIONS
/////////////////////////////////
/**
* Action to do when agent has an enemy at sight.
* 
* This method is called when agent has looked and has found an enemy,
* calculating (in agreement to the enemy position) the new direction where
* is aiming.
* 
*/
+!perform_aim_action
    <-  // Aimed agents have the following format:
        // [#, TEAM, TYPE, ANGLE, DISTANCE, HEALTH, POSITION ]
        ?aimed_agent(AimedAgent);
        .println("AimedAgent ", AimedAgent);
        .nth(1, AimedAgent, AimedAgentTeam);
        .println("BAJO EL PUNTO DE MIRA TENGO A ALGUIEN DEL EQUIPO ", AimedAgentTeam);
        ?my_formattedTeam(MyTeam);
        if (MyTeam == Team) {
            .println("We are at the same team!!");
        };
        
        .nth(6, AimedAgent, NewDestination);
        .println("NUEVO DESTINO MARCADO: ", NewDestination);
        update_destination(NewDestination).
    
/**
* Action to do when the agent is looking at.
* 
* This method is called just after Look method has ended.
* 
* <em> It's very useful to overload this method. </em>
* 
*/
+!perform_look_action 
    <-  .println("YOUR CODE FOR PERFORM_LOOK_ACTION GOES HERE.").

/**
* Action to do if this agent cannot shoot.
* 
* This method is called when the agent try to shoot, but has no ammo. The
* agent will spit enemies out. :-)
* 
* <em> It's very useful to overload this method. </em>
* 
*/  
+!perform_no_ammo_action 
    <-  .println("YOUR CODE FOR PERFORM_NO_AMMO_ACTION GOES HERE.").
    
/**
     * Action to do when an agent is being shot.
     * 
     * This method is called every time this agent receives a messager from
     * agent Manager informing it is being shot.
     * 
     * <em> It's very useful to overload this method. </em>
     * 
     */
+!perform_injury_action
    <-  .println("YOUR CODE FOR PERFORM_INJURY_ACTION GOES HERE."). 
        

/////////////////////////////////
//  SETUP PRIORITIES
/////////////////////////////////
+!setup_priorities
    <-  +task_priority("TASK_NONE",0);
        +task_priority("TASK_GIVE_MEDICPAKS", 2000);
        +task_priority("TASK_GIVE_AMMOPACKS", 0);
        +task_priority("TASK_GIVE_BACKUP", 0);
        +task_priority("TASK_GET_OBJECTIVE",1000);
        +task_priority("TASK_ATTACK", 1000);
        +task_priority("TASK_RUN_AWAY", 1500);
        +task_priority("TASK_GOTO_POSITION", 750);
        +task_priority("TASK_PATROLLING", 500);
        +task_priority("TASK_WALKING_PATH", 750).   


/////////////////////////////////
//  SHOOTING TO ME
/////////////////////////////////
+shooting_to_me(Bullets)[source(M)]
    <-  ?my_health(Health);
        NewHealth = Health - Bullets;
        -+my_health(NewHealth);
        .println("HE RECIBIDO ", Bullets, " DISPAROS.");
        !perform_injury_action;
        -shooting_to_me(_)[source(M)].
    

/////////////////////////////////
//  MEDIC_PACK TAKEN
/////////////////////////////////
+medic_pack_taken(Medicine)[source(M)]
    <-  ?my_health(Health);
        NewHealth = Health + Medicine;
        -+my_health(NewHealth);
        .println("HE RECIBIDO ", Medicine, " SALUD.");
        -medic_pack_taken(_)[source(M)].


/////////////////////////////////
//  AMMO_PACK TAKEN
/////////////////////////////////
+ammo_pack_taken(Bullets)[source(M)]
    <-  ?my_ammo(Ammo);
        NewAmmo = Ammo + Bullets;
        -+my_ammo(NewAmmo);
        .println("HE RECIBIDO ", Bullets, " BALAS.");
        -ammo_pack_taken(_)[source(M)].


            
/////////////////////////////////
//  SHOT
/////////////////////////////////
+!shot(Shot) : my_ammo(Ammo) & Ammo > 0 & aimed_agent 
			& manager(M) & assigned_id(AssignedID) 
			& my_aim_threshold(AimThreshold) & my_shot_threshold(ShotThreshold)
	<- 	ShotValue = ShotThreshold - Shot;
		.concat("ID: ",AssignedID, " AIM: ", AimThreshold, " #SHOT: ", ShotValue, " ", Content);
   		.send_msg_with_conversation_id(M, tell, Content, "SHOT");
        .println("ESTOY DIPARANDO.");
   		NewAmmo = Ammo - 1;
   		-+my_ammo(NewAmmo).

+!shot(Shot) : my_ammo(Ammo) & Ammo <= 0  
	<-	.println("I have no ammo.");
		!perform_no_ammo_action.	
	
+!shot(Shot) : not aimed_agent
	<-	.println("No aimed enemy to shot.").


/////////////////////////////////
//  START
/////////////////////////////////
+!start : .my_name(MyName) & manager(M) & team(MyTeam) & type(MyType)
	<- 	// Setup values
        
        .setlogfile("logs/agente.log");
		+my_health(100);
		+my_protection(25);
		+my_stamina(100);
		+my_power(100);
		+my_ammo(100);
		
		// Threshold
		+my_aim_threshold(1);
		+my_ammo_threshold(50);
		+my_health_threshold(50);
		+my_look_threshold(1);
		+my_shot_threshold(1);
		
		.println("I'm ready");
   		.get_type(MyType,FormattedType);
   		+my_formattedType(FormattedType);
   		.get_team(MyTeam,FormattedTeam);
   		+my_formattedTeam(FormattedTeam);
   		
   		.concat("ID: 0 Name: ", MyName, " TYPE: ", FormattedType, " TEAM: ", FormattedTeam, X);
   		.send_msg_with_conversation_id(M, tell, X, "INIT");
   		.println("Sent 'INIT' message to ", M);
   		agent_setup.


/////////////////////////////////
//  UPDATE TARGETS
///////////////////////////////// 
+!update_targets 
	<-	.println("YOUR CODE FOR UPDATE_TARGETS GOES HERE.").
